﻿Imports System
Imports System.Collections.Generic

Namespace Logging
    Public Class Log
        Private Shared _instance As Log = Nothing

        Public Shared ReadOnly Property Instance As Log
            Get

                If _instance Is Nothing Then
                    _instance = New Log()
                End If

                Return _instance
            End Get
        End Property

        Private ReadOnly dictionary As Dictionary(Of Integer, LogRecord) = New Dictionary(Of Integer, LogRecord)()
        Public Event NewData As EventHandler(Of LogRecord)

        Private Sub Add(args As LogRecord)
            dictionary.Add(dictionary.Count, args)
            RaiseEvent NewData(Instance, args)
        End Sub
        Public Function GetData() As List(Of LogRecord)
            Dim arr As LogRecord() = New LogRecord(dictionary.Count - 1) {}
            dictionary.Values.CopyTo(arr, 0)
            Dim list As List(Of LogRecord) = New List(Of LogRecord)(arr)
            Return list
        End Function

        Private Sub New()
        End Sub

        Public Shared Sub Add(ByVal source As String, ByVal message As String)
            Dim args As LogRecord = New LogRecord(source, message)
            Instance.Add(args)
        End Sub

        Public Shared Sub Add(ByVal source As String, ByVal ex As Exception)
            Dim args As LogRecord = New LogRecord(source, ex.ToString())
            Instance.Add(args)
        End Sub
    End Class
End Namespace
