﻿Imports System

Namespace Logging
    Public Class LogRecord
        Inherits EventArgs

        Public Property Time As String
        Public Property Sender As String
        Public Property Message As String

        Public Sub New(ByVal sender As String, ByVal message As String)
            Time = DateTime.Now.ToString("hh:mm:ss.fff tt")
            Me.Sender = sender
            Me.Message = message
        End Sub

        Public Overrides Function ToString() As String
            Return String.Format("{0} {1} " & vbLf & "{2}", Time, Sender, Message)
        End Function
    End Class
End Namespace